/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.adaptation.Action;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess;
import edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration;
import edu.kit.ipd.descartes.mm.adaptation.OverallGoal;
import edu.kit.ipd.descartes.mm.adaptation.Parameter;
import edu.kit.ipd.descartes.mm.adaptation.Strategy;
import edu.kit.ipd.descartes.mm.adaptation.Tactic;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Process</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getTactics <em>Tactics</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getActions <em>Actions</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getStrategies <em>Strategies</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getParameters <em>Parameters</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getGoal <em>Goal</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl#getImportDeclaration <em>Import Declaration</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AdaptationProcessImpl extends EntityImpl implements AdaptationProcess {
    /**
	 * The cached value of the '{@link #getTactics() <em>Tactics</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTactics()
	 * @generated
	 * @ordered
	 */
    protected EList<Tactic> tactics;

    /**
	 * The cached value of the '{@link #getActions() <em>Actions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getActions()
	 * @generated
	 * @ordered
	 */
    protected EList<Action> actions;

    /**
	 * The cached value of the '{@link #getStrategies() <em>Strategies</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getStrategies()
	 * @generated
	 * @ordered
	 */
    protected EList<Strategy> strategies;

    /**
	 * The cached value of the '{@link #getParameters() <em>Parameters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getParameters()
	 * @generated
	 * @ordered
	 */
    protected EList<Parameter> parameters;

    /**
	 * The cached value of the '{@link #getGoal() <em>Goal</em>}' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getGoal()
	 * @generated
	 * @ordered
	 */
    protected OverallGoal goal;

    /**
	 * The cached value of the '{@link #getImportDeclaration() <em>Import Declaration</em>}' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getImportDeclaration()
	 * @generated
	 * @ordered
	 */
    protected EList<ImportDeclaration> importDeclaration;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected AdaptationProcessImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.ADAPTATION_PROCESS;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Tactic> getTactics() {
		if (tactics == null) {
			tactics = new EObjectContainmentEList<Tactic>(Tactic.class, this, AdaptationPackage.ADAPTATION_PROCESS__TACTICS);
		}
		return tactics;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Action> getActions() {
		if (actions == null) {
			actions = new EObjectContainmentEList<Action>(Action.class, this, AdaptationPackage.ADAPTATION_PROCESS__ACTIONS);
		}
		return actions;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Strategy> getStrategies() {
		if (strategies == null) {
			strategies = new EObjectContainmentEList<Strategy>(Strategy.class, this, AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES);
		}
		return strategies;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<Parameter> getParameters() {
		if (parameters == null) {
			parameters = new EObjectContainmentEList<Parameter>(Parameter.class, this, AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS);
		}
		return parameters;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public OverallGoal getGoal() {
		return goal;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public NotificationChain basicSetGoal(OverallGoal newGoal, NotificationChain msgs) {
		OverallGoal oldGoal = goal;
		goal = newGoal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.ADAPTATION_PROCESS__GOAL, oldGoal, newGoal);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setGoal(OverallGoal newGoal) {
		if (newGoal != goal) {
			NotificationChain msgs = null;
			if (goal != null)
				msgs = ((InternalEObject)goal).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.ADAPTATION_PROCESS__GOAL, null, msgs);
			if (newGoal != null)
				msgs = ((InternalEObject)newGoal).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.ADAPTATION_PROCESS__GOAL, null, msgs);
			msgs = basicSetGoal(newGoal, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.ADAPTATION_PROCESS__GOAL, newGoal, newGoal));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public EList<ImportDeclaration> getImportDeclaration() {
		if (importDeclaration == null) {
			importDeclaration = new EObjectContainmentEList<ImportDeclaration>(ImportDeclaration.class, this, AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION);
		}
		return importDeclaration;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
				return ((InternalEList<?>)getTactics()).basicRemove(otherEnd, msgs);
			case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
				return ((InternalEList<?>)getActions()).basicRemove(otherEnd, msgs);
			case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
				return ((InternalEList<?>)getStrategies()).basicRemove(otherEnd, msgs);
			case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
				return ((InternalEList<?>)getParameters()).basicRemove(otherEnd, msgs);
			case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
				return basicSetGoal(null, msgs);
			case AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION:
				return ((InternalEList<?>)getImportDeclaration()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
				return getTactics();
			case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
				return getActions();
			case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
				return getStrategies();
			case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
				return getParameters();
			case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
				return getGoal();
			case AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION:
				return getImportDeclaration();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
				getTactics().clear();
				getTactics().addAll((Collection<? extends Tactic>)newValue);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
				getActions().clear();
				getActions().addAll((Collection<? extends Action>)newValue);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
				getStrategies().clear();
				getStrategies().addAll((Collection<? extends Strategy>)newValue);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
				getParameters().clear();
				getParameters().addAll((Collection<? extends Parameter>)newValue);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
				setGoal((OverallGoal)newValue);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION:
				getImportDeclaration().clear();
				getImportDeclaration().addAll((Collection<? extends ImportDeclaration>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
				getTactics().clear();
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
				getActions().clear();
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
				getStrategies().clear();
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
				getParameters().clear();
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
				setGoal((OverallGoal)null);
				return;
			case AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION:
				getImportDeclaration().clear();
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
				return tactics != null && !tactics.isEmpty();
			case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
				return actions != null && !actions.isEmpty();
			case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
				return strategies != null && !strategies.isEmpty();
			case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
				return parameters != null && !parameters.isEmpty();
			case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
				return goal != null;
			case AdaptationPackage.ADAPTATION_PROCESS__IMPORT_DECLARATION:
				return importDeclaration != null && !importDeclaration.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //AdaptationProcessImpl
