/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallFrequency;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;
import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Coarse Grained Behavior</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.CoarseGrainedBehaviorImpl#getExternalCallFrequency <em>External Call Frequency</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.CoarseGrainedBehaviorImpl#getResourceDemand <em>Resource Demand</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CoarseGrainedBehaviorImpl extends ServiceBehaviorAbstractionImpl implements CoarseGrainedBehavior {
	/**
	 * The cached value of the '{@link #getExternalCallFrequency() <em>External Call Frequency</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternalCallFrequency()
	 * @generated
	 * @ordered
	 */
	protected EList<ExternalCallFrequency> externalCallFrequency;

	/**
	 * The cached value of the '{@link #getResourceDemand() <em>Resource Demand</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getResourceDemand()
	 * @generated
	 * @ordered
	 */
	protected EList<ResourceDemand> resourceDemand;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoarseGrainedBehaviorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.COARSE_GRAINED_BEHAVIOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ExternalCallFrequency> getExternalCallFrequency() {
		if (externalCallFrequency == null) {
			externalCallFrequency = new EObjectContainmentWithInverseEList<ExternalCallFrequency>(ExternalCallFrequency.class, this, ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY, ServicebehaviorPackage.EXTERNAL_CALL_FREQUENCY__COARSE_GRAINED_BEHAVIOR);
		}
		return externalCallFrequency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ResourceDemand> getResourceDemand() {
		if (resourceDemand == null) {
			resourceDemand = new EObjectContainmentWithInverseEList<ResourceDemand>(ResourceDemand.class, this, ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND, ServicebehaviorPackage.RESOURCE_DEMAND__COARSE_GRAINED_BEHAVIOR);
		}
		return resourceDemand;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getExternalCallFrequency()).basicAdd(otherEnd, msgs);
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getResourceDemand()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				return ((InternalEList<?>)getExternalCallFrequency()).basicRemove(otherEnd, msgs);
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				return ((InternalEList<?>)getResourceDemand()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				return getExternalCallFrequency();
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				return getResourceDemand();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				getExternalCallFrequency().clear();
				getExternalCallFrequency().addAll((Collection<? extends ExternalCallFrequency>)newValue);
				return;
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				getResourceDemand().clear();
				getResourceDemand().addAll((Collection<? extends ResourceDemand>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				getExternalCallFrequency().clear();
				return;
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				getResourceDemand().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__EXTERNAL_CALL_FREQUENCY:
				return externalCallFrequency != null && !externalCallFrequency.isEmpty();
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR__RESOURCE_DEMAND:
				return resourceDemand != null && !resourceDemand.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //CoarseGrainedBehaviorImpl
