/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourceconfiguration.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.NumberOfParallelProcessingUnits;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage;
import edu.kit.ipd.descartes.mm.resourceconfiguration.SchedulingPolicy;

import edu.kit.ipd.descartes.mm.resourcetype.ProcessingResourceType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Processing Resource Specification</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ProcessingResourceSpecificationImpl#getSchedulingPolicy <em>Scheduling Policy</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ProcessingResourceSpecificationImpl#getProcessingRate <em>Processing Rate</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ProcessingResourceSpecificationImpl#getActiveResourceType <em>Active Resource Type</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ProcessingResourceSpecificationImpl#getParentResourceSpecification <em>Parent Resource Specification</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ProcessingResourceSpecificationImpl#getNrOfParProcUnits <em>Nr Of Par Proc Units</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProcessingResourceSpecificationImpl extends EntityImpl implements ProcessingResourceSpecification {
	/**
     * The default value of the '{@link #getSchedulingPolicy() <em>Scheduling Policy</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getSchedulingPolicy()
     * @generated
     * @ordered
     */
	protected static final SchedulingPolicy SCHEDULING_POLICY_EDEFAULT = SchedulingPolicy.DELAY;

	/**
     * The cached value of the '{@link #getSchedulingPolicy() <em>Scheduling Policy</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getSchedulingPolicy()
     * @generated
     * @ordered
     */
	protected SchedulingPolicy schedulingPolicy = SCHEDULING_POLICY_EDEFAULT;

	/**
     * The default value of the '{@link #getProcessingRate() <em>Processing Rate</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getProcessingRate()
     * @generated
     * @ordered
     */
	protected static final double PROCESSING_RATE_EDEFAULT = 0.0;

	/**
     * The cached value of the '{@link #getProcessingRate() <em>Processing Rate</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getProcessingRate()
     * @generated
     * @ordered
     */
	protected double processingRate = PROCESSING_RATE_EDEFAULT;

	/**
     * The cached value of the '{@link #getActiveResourceType() <em>Active Resource Type</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getActiveResourceType()
     * @generated
     * @ordered
     */
	protected ProcessingResourceType activeResourceType;

	/**
     * The cached value of the '{@link #getNrOfParProcUnits() <em>Nr Of Par Proc Units</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getNrOfParProcUnits()
     * @generated
     * @ordered
     */
	protected NumberOfParallelProcessingUnits nrOfParProcUnits;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected ProcessingResourceSpecificationImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return ResourceconfigurationPackage.Literals.PROCESSING_RESOURCE_SPECIFICATION;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SchedulingPolicy getSchedulingPolicy() {
        return schedulingPolicy;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setSchedulingPolicy(SchedulingPolicy newSchedulingPolicy) {
        SchedulingPolicy oldSchedulingPolicy = schedulingPolicy;
        schedulingPolicy = newSchedulingPolicy == null ? SCHEDULING_POLICY_EDEFAULT : newSchedulingPolicy;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__SCHEDULING_POLICY, oldSchedulingPolicy, schedulingPolicy));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public double getProcessingRate() {
        return processingRate;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setProcessingRate(double newProcessingRate) {
        double oldProcessingRate = processingRate;
        processingRate = newProcessingRate;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PROCESSING_RATE, oldProcessingRate, processingRate));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ProcessingResourceType getActiveResourceType() {
        if (activeResourceType != null && activeResourceType.eIsProxy()) {
            InternalEObject oldActiveResourceType = (InternalEObject)activeResourceType;
            activeResourceType = (ProcessingResourceType)eResolveProxy(oldActiveResourceType);
            if (activeResourceType != oldActiveResourceType) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE, oldActiveResourceType, activeResourceType));
            }
        }
        return activeResourceType;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ProcessingResourceType basicGetActiveResourceType() {
        return activeResourceType;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setActiveResourceType(ProcessingResourceType newActiveResourceType) {
        ProcessingResourceType oldActiveResourceType = activeResourceType;
        activeResourceType = newActiveResourceType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE, oldActiveResourceType, activeResourceType));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ActiveResourceSpecification getParentResourceSpecification() {
        if (eContainerFeatureID() != ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION) return null;
        return (ActiveResourceSpecification)eContainer();
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetParentResourceSpecification(ActiveResourceSpecification newParentResourceSpecification, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newParentResourceSpecification, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION, msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setParentResourceSpecification(ActiveResourceSpecification newParentResourceSpecification) {
        if (newParentResourceSpecification != eInternalContainer() || (eContainerFeatureID() != ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION && newParentResourceSpecification != null)) {
            if (EcoreUtil.isAncestor(this, newParentResourceSpecification))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newParentResourceSpecification != null)
                msgs = ((InternalEObject)newParentResourceSpecification).eInverseAdd(this, ResourceconfigurationPackage.ACTIVE_RESOURCE_SPECIFICATION__PROCESSING_RESOURCE_SPECIFICATIONS, ActiveResourceSpecification.class, msgs);
            msgs = basicSetParentResourceSpecification(newParentResourceSpecification, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION, newParentResourceSpecification, newParentResourceSpecification));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NumberOfParallelProcessingUnits getNrOfParProcUnits() {
        return nrOfParProcUnits;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetNrOfParProcUnits(NumberOfParallelProcessingUnits newNrOfParProcUnits, NotificationChain msgs) {
        NumberOfParallelProcessingUnits oldNrOfParProcUnits = nrOfParProcUnits;
        nrOfParProcUnits = newNrOfParProcUnits;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS, oldNrOfParProcUnits, newNrOfParProcUnits);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setNrOfParProcUnits(NumberOfParallelProcessingUnits newNrOfParProcUnits) {
        if (newNrOfParProcUnits != nrOfParProcUnits) {
            NotificationChain msgs = null;
            if (nrOfParProcUnits != null)
                msgs = ((InternalEObject)nrOfParProcUnits).eInverseRemove(this, ResourceconfigurationPackage.NUMBER_OF_PARALLEL_PROCESSING_UNITS__PROCESSING_RESOURCE_SPEC, NumberOfParallelProcessingUnits.class, msgs);
            if (newNrOfParProcUnits != null)
                msgs = ((InternalEObject)newNrOfParProcUnits).eInverseAdd(this, ResourceconfigurationPackage.NUMBER_OF_PARALLEL_PROCESSING_UNITS__PROCESSING_RESOURCE_SPEC, NumberOfParallelProcessingUnits.class, msgs);
            msgs = basicSetNrOfParProcUnits(newNrOfParProcUnits, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS, newNrOfParProcUnits, newNrOfParProcUnits));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetParentResourceSpecification((ActiveResourceSpecification)otherEnd, msgs);
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                if (nrOfParProcUnits != null)
                    msgs = ((InternalEObject)nrOfParProcUnits).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS, null, msgs);
                return basicSetNrOfParProcUnits((NumberOfParallelProcessingUnits)otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                return basicSetParentResourceSpecification(null, msgs);
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                return basicSetNrOfParProcUnits(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                return eInternalContainer().eInverseRemove(this, ResourceconfigurationPackage.ACTIVE_RESOURCE_SPECIFICATION__PROCESSING_RESOURCE_SPECIFICATIONS, ActiveResourceSpecification.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__SCHEDULING_POLICY:
                return getSchedulingPolicy();
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PROCESSING_RATE:
                return getProcessingRate();
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE:
                if (resolve) return getActiveResourceType();
                return basicGetActiveResourceType();
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                return getParentResourceSpecification();
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                return getNrOfParProcUnits();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__SCHEDULING_POLICY:
                setSchedulingPolicy((SchedulingPolicy)newValue);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PROCESSING_RATE:
                setProcessingRate((Double)newValue);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE:
                setActiveResourceType((ProcessingResourceType)newValue);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                setParentResourceSpecification((ActiveResourceSpecification)newValue);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                setNrOfParProcUnits((NumberOfParallelProcessingUnits)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__SCHEDULING_POLICY:
                setSchedulingPolicy(SCHEDULING_POLICY_EDEFAULT);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PROCESSING_RATE:
                setProcessingRate(PROCESSING_RATE_EDEFAULT);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE:
                setActiveResourceType((ProcessingResourceType)null);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                setParentResourceSpecification((ActiveResourceSpecification)null);
                return;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                setNrOfParProcUnits((NumberOfParallelProcessingUnits)null);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__SCHEDULING_POLICY:
                return schedulingPolicy != SCHEDULING_POLICY_EDEFAULT;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PROCESSING_RATE:
                return processingRate != PROCESSING_RATE_EDEFAULT;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__ACTIVE_RESOURCE_TYPE:
                return activeResourceType != null;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__PARENT_RESOURCE_SPECIFICATION:
                return getParentResourceSpecification() != null;
            case ResourceconfigurationPackage.PROCESSING_RESOURCE_SPECIFICATION__NR_OF_PAR_PROC_UNITS:
                return nrOfParProcUnits != null;
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (schedulingPolicy: ");
        result.append(schedulingPolicy);
        result.append(", processingRate: ");
        result.append(processingRate);
        result.append(')');
        return result.toString();
    }

} //ProcessingResourceSpecificationImpl
