/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.impl;

import edu.kit.ipd.descartes.core.CorePackage;

import edu.kit.ipd.descartes.mm.containerrepository.ContainerrepositoryPackage;

import edu.kit.ipd.descartes.mm.containerrepository.impl.ContainerrepositoryPackageImpl;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage;

import edu.kit.ipd.descartes.mm.resourceconfiguration.impl.ResourceconfigurationPackageImpl;

import edu.kit.ipd.descartes.mm.resourcelandscape.AbstractHardwareInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.CompositeHardwareInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.ComputingInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.HardwareInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.NetworkingInfrastructure;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment;
import edu.kit.ipd.descartes.mm.resourcelandscape.StorageInfrastructure;

import edu.kit.ipd.descartes.mm.resourcelandscape.util.ResourcelandscapeValidator;

import edu.kit.ipd.descartes.mm.resourcetype.ResourcetypePackage;

import edu.kit.ipd.descartes.mm.resourcetype.impl.ResourcetypePackageImpl;

import edu.kit.ipd.descartes.mm.runtimeenvironmentclasses.RuntimeenvironmentclassesPackage;

import edu.kit.ipd.descartes.mm.runtimeenvironmentclasses.impl.RuntimeenvironmentclassesPackageImpl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ResourcelandscapePackageImpl extends EPackageImpl implements ResourcelandscapePackage {
	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass computingInfrastructureEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass networkingInfrastructureEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass storageInfrastructureEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass containerEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass runtimeEnvironmentEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass dataCenterEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass distributedDataCenterEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass compositeHardwareInfrastructureEClass = null;

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass hardwareInfrastructureEClass = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage#eNS_URI
     * @see #init()
     * @generated
     */
	private ResourcelandscapePackageImpl() {
        super(eNS_URI, ResourcelandscapeFactory.eINSTANCE);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static boolean isInited = false;

	/**
     * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
     * 
     * <p>This method is used to initialize {@link ResourcelandscapePackage#eINSTANCE} when that field is accessed.
     * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
	public static ResourcelandscapePackage init() {
        if (isInited) return (ResourcelandscapePackage)EPackage.Registry.INSTANCE.getEPackage(ResourcelandscapePackage.eNS_URI);

        // Obtain or create and register package
        ResourcelandscapePackageImpl theResourcelandscapePackage = (ResourcelandscapePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ResourcelandscapePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ResourcelandscapePackageImpl());

        isInited = true;

        // Initialize simple dependencies
        CorePackage.eINSTANCE.eClass();

        // Obtain or create and register interdependencies
        ResourceconfigurationPackageImpl theResourceconfigurationPackage = (ResourceconfigurationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ResourceconfigurationPackage.eNS_URI) instanceof ResourceconfigurationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ResourceconfigurationPackage.eNS_URI) : ResourceconfigurationPackage.eINSTANCE);
        ContainerrepositoryPackageImpl theContainerrepositoryPackage = (ContainerrepositoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContainerrepositoryPackage.eNS_URI) instanceof ContainerrepositoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContainerrepositoryPackage.eNS_URI) : ContainerrepositoryPackage.eINSTANCE);
        RuntimeenvironmentclassesPackageImpl theRuntimeenvironmentclassesPackage = (RuntimeenvironmentclassesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RuntimeenvironmentclassesPackage.eNS_URI) instanceof RuntimeenvironmentclassesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RuntimeenvironmentclassesPackage.eNS_URI) : RuntimeenvironmentclassesPackage.eINSTANCE);
        ResourcetypePackageImpl theResourcetypePackage = (ResourcetypePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ResourcetypePackage.eNS_URI) instanceof ResourcetypePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ResourcetypePackage.eNS_URI) : ResourcetypePackage.eINSTANCE);

        // Create package meta-data objects
        theResourcelandscapePackage.createPackageContents();
        theResourceconfigurationPackage.createPackageContents();
        theContainerrepositoryPackage.createPackageContents();
        theRuntimeenvironmentclassesPackage.createPackageContents();
        theResourcetypePackage.createPackageContents();

        // Initialize created meta-data
        theResourcelandscapePackage.initializePackageContents();
        theResourceconfigurationPackage.initializePackageContents();
        theContainerrepositoryPackage.initializePackageContents();
        theRuntimeenvironmentclassesPackage.initializePackageContents();
        theResourcetypePackage.initializePackageContents();

        // Register package validator
        EValidator.Registry.INSTANCE.put
            (theResourcelandscapePackage, 
             new EValidator.Descriptor() {
                 public EValidator getEValidator() {
                     return ResourcelandscapeValidator.INSTANCE;
                 }
             });

        // Mark meta-data to indicate it can't be changed
        theResourcelandscapePackage.freeze();

  
        // Update the registry and return the package
        EPackage.Registry.INSTANCE.put(ResourcelandscapePackage.eNS_URI, theResourcelandscapePackage);
        return theResourcelandscapePackage;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getComputingInfrastructure() {
        return computingInfrastructureEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getNetworkingInfrastructure() {
        return networkingInfrastructureEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getStorageInfrastructure() {
        return storageInfrastructureEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getContainer() {
        return containerEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getContainer_Contains() {
        return (EReference)containerEClass.getEStructuralFeatures().get(0);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getContainer_ConfigSpec() {
        return (EReference)containerEClass.getEStructuralFeatures().get(1);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getContainer_Template() {
        return (EReference)containerEClass.getEStructuralFeatures().get(2);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getRuntimeEnvironment() {
        return runtimeEnvironmentEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getRuntimeEnvironment_ContainedIn() {
        return (EReference)runtimeEnvironmentEClass.getEStructuralFeatures().get(0);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EAttribute getRuntimeEnvironment_OfClass() {
        return (EAttribute)runtimeEnvironmentEClass.getEStructuralFeatures().get(1);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getDataCenter() {
        return dataCenterEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getDataCenter_BelongsTo() {
        return (EReference)dataCenterEClass.getEStructuralFeatures().get(0);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getDataCenter_Contains() {
        return (EReference)dataCenterEClass.getEStructuralFeatures().get(1);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getDistributedDataCenter() {
        return distributedDataCenterEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getDistributedDataCenter_ConsistsOf() {
        return (EReference)distributedDataCenterEClass.getEStructuralFeatures().get(0);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EClass getCompositeHardwareInfrastructure() {
        return compositeHardwareInfrastructureEClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EReference getCompositeHardwareInfrastructure_Contains() {
        return (EReference)compositeHardwareInfrastructureEClass.getEStructuralFeatures().get(0);
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getHardwareInfrastructure() {
        return hardwareInfrastructureEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getHardwareInfrastructure_PartOf() {
        return (EReference)hardwareInfrastructureEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ResourcelandscapeFactory getResourcelandscapeFactory() {
        return (ResourcelandscapeFactory)getEFactoryInstance();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private boolean isCreated = false;

	/**
     * Creates the meta-model objects for the package.  This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void createPackageContents() {
        if (isCreated) return;
        isCreated = true;

        // Create classes and their features
        computingInfrastructureEClass = createEClass(COMPUTING_INFRASTRUCTURE);

        networkingInfrastructureEClass = createEClass(NETWORKING_INFRASTRUCTURE);

        storageInfrastructureEClass = createEClass(STORAGE_INFRASTRUCTURE);

        containerEClass = createEClass(CONTAINER);
        createEReference(containerEClass, CONTAINER__CONTAINS);
        createEReference(containerEClass, CONTAINER__CONFIG_SPEC);
        createEReference(containerEClass, CONTAINER__TEMPLATE);

        runtimeEnvironmentEClass = createEClass(RUNTIME_ENVIRONMENT);
        createEReference(runtimeEnvironmentEClass, RUNTIME_ENVIRONMENT__CONTAINED_IN);
        createEAttribute(runtimeEnvironmentEClass, RUNTIME_ENVIRONMENT__OF_CLASS);

        dataCenterEClass = createEClass(DATA_CENTER);
        createEReference(dataCenterEClass, DATA_CENTER__BELONGS_TO);
        createEReference(dataCenterEClass, DATA_CENTER__CONTAINS);

        distributedDataCenterEClass = createEClass(DISTRIBUTED_DATA_CENTER);
        createEReference(distributedDataCenterEClass, DISTRIBUTED_DATA_CENTER__CONSISTS_OF);

        compositeHardwareInfrastructureEClass = createEClass(COMPOSITE_HARDWARE_INFRASTRUCTURE);
        createEReference(compositeHardwareInfrastructureEClass, COMPOSITE_HARDWARE_INFRASTRUCTURE__CONTAINS);

        hardwareInfrastructureEClass = createEClass(HARDWARE_INFRASTRUCTURE);
        createEReference(hardwareInfrastructureEClass, HARDWARE_INFRASTRUCTURE__PART_OF);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private boolean isInitialized = false;

	/**
     * Complete the initialization of the package and its meta-model.  This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void initializePackageContents() {
        if (isInitialized) return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
        ResourceconfigurationPackage theResourceconfigurationPackage = (ResourceconfigurationPackage)EPackage.Registry.INSTANCE.getEPackage(ResourceconfigurationPackage.eNS_URI);
        ContainerrepositoryPackage theContainerrepositoryPackage = (ContainerrepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(ContainerrepositoryPackage.eNS_URI);
        RuntimeenvironmentclassesPackage theRuntimeenvironmentclassesPackage = (RuntimeenvironmentclassesPackage)EPackage.Registry.INSTANCE.getEPackage(RuntimeenvironmentclassesPackage.eNS_URI);

        // Create type parameters

        // Set bounds for type parameters

        // Add supertypes to classes
        computingInfrastructureEClass.getESuperTypes().add(this.getContainer());
        computingInfrastructureEClass.getESuperTypes().add(this.getHardwareInfrastructure());
        networkingInfrastructureEClass.getESuperTypes().add(this.getContainer());
        networkingInfrastructureEClass.getESuperTypes().add(this.getHardwareInfrastructure());
        storageInfrastructureEClass.getESuperTypes().add(this.getContainer());
        storageInfrastructureEClass.getESuperTypes().add(this.getHardwareInfrastructure());
        containerEClass.getESuperTypes().add(theCorePackage.getEntity());
        runtimeEnvironmentEClass.getESuperTypes().add(this.getContainer());
        dataCenterEClass.getESuperTypes().add(theCorePackage.getEntity());
        distributedDataCenterEClass.getESuperTypes().add(theCorePackage.getEntity());
        compositeHardwareInfrastructureEClass.getESuperTypes().add(this.getHardwareInfrastructure());
        hardwareInfrastructureEClass.getESuperTypes().add(theCorePackage.getEntity());

        // Initialize classes and features; add operations and parameters
        initEClass(computingInfrastructureEClass, ComputingInfrastructure.class, "ComputingInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(networkingInfrastructureEClass, NetworkingInfrastructure.class, "NetworkingInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(storageInfrastructureEClass, StorageInfrastructure.class, "StorageInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(containerEClass, edu.kit.ipd.descartes.mm.resourcelandscape.Container.class, "Container", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getContainer_Contains(), this.getRuntimeEnvironment(), this.getRuntimeEnvironment_ContainedIn(), "contains", null, 0, -1, edu.kit.ipd.descartes.mm.resourcelandscape.Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getContainer_ConfigSpec(), theResourceconfigurationPackage.getConfigurationSpecification(), null, "configSpec", null, 0, -1, edu.kit.ipd.descartes.mm.resourcelandscape.Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getContainer_Template(), theContainerrepositoryPackage.getContainerTemplate(), null, "template", null, 0, 1, edu.kit.ipd.descartes.mm.resourcelandscape.Container.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(runtimeEnvironmentEClass, RuntimeEnvironment.class, "RuntimeEnvironment", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getRuntimeEnvironment_ContainedIn(), this.getContainer(), this.getContainer_Contains(), "containedIn", null, 1, 1, RuntimeEnvironment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getRuntimeEnvironment_OfClass(), theRuntimeenvironmentclassesPackage.getRuntimeEnvironmentClasses(), "ofClass", null, 1, 1, RuntimeEnvironment.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(dataCenterEClass, DataCenter.class, "DataCenter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getDataCenter_BelongsTo(), this.getDistributedDataCenter(), this.getDistributedDataCenter_ConsistsOf(), "belongsTo", null, 0, 1, DataCenter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getDataCenter_Contains(), this.getHardwareInfrastructure(), this.getHardwareInfrastructure_PartOf(), "contains", null, 0, -1, DataCenter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(distributedDataCenterEClass, DistributedDataCenter.class, "DistributedDataCenter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getDistributedDataCenter_ConsistsOf(), this.getDataCenter(), this.getDataCenter_BelongsTo(), "consistsOf", null, 1, -1, DistributedDataCenter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(compositeHardwareInfrastructureEClass, CompositeHardwareInfrastructure.class, "CompositeHardwareInfrastructure", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getCompositeHardwareInfrastructure_Contains(), this.getHardwareInfrastructure(), null, "contains", null, 0, -1, CompositeHardwareInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(hardwareInfrastructureEClass, HardwareInfrastructure.class, "HardwareInfrastructure", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getHardwareInfrastructure_PartOf(), this.getDataCenter(), this.getDataCenter_Contains(), "partOf", null, 0, 1, HardwareInfrastructure.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        // Create resource
        createResource(eNS_URI);

        // Create annotations
        // http://www.eclipse.org/emf/2002/Ecore
        createEcoreAnnotations();
        // http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
        createPivotAnnotations();
    }

	/**
     * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected void createEcoreAnnotations() {
        String source = "http://www.eclipse.org/emf/2002/Ecore";		
        addAnnotation
          (this, 
           source, 
           new String[] {
             "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
             "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
             "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
           });		
        addAnnotation
          (runtimeEnvironmentEClass, 
           source, 
           new String[] {
             "constraints", "runtimeEnvironmentLevelCompliance"
           });	
    }

	/**
     * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected void createPivotAnnotations() {
        String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";				
        addAnnotation
          (runtimeEnvironmentEClass, 
           source, 
           new String[] {
             "runtimeEnvironmentLevelCompliance", "self.containedIn.contains->forAll(r : RuntimeEnvironment | r.ofClass = self.ofClass)"
           });
    }

} //ResourcelandscapePackageImpl
